;---------------------------------------------------------------------

  use32              ;  32- ० ᥬ
  org    0           ;   

  db     'MENUET01'  ; 8- 䨪 MenuetOS
  dd     1           ;   (1  2, . -)
  dd     START       ;  ࢮ 
  dd     I_END       ; ࠧ ணࠬ
  dd     MEM         ; ⢮ 
  dd     STACKTOP    ;  設 
  dd     0           ;    ࠬ஢
  dd     0           ; १ࢨ஢

include "macros.inc" ;    ᥬ騪!

;---------------------------------------------------------------------
;---     ----------------------------------------------
;---------------------------------------------------------------------

include 'XO_CAS_V1.inc'
include 'XO_WinCon.inc'
include 'XO_Draw.inc'

START:


mov eax, 40
mov ebx, 100111b
int 0x40


red:                    ; ᮢ 

    call draw_window    ; 뢠 楤 ᮢ 

;---------------------------------------------------------------------
;---      ----------------------------------------
;---------------------------------------------------------------------

still:

    mcall 10            ; 㭪 10 -  ᮡ

    cmp  eax,1          ; ᮢ  ?
    je   red            ; ᫨  -   red
    cmp  eax,2
    je   key
    cmp  eax,3          ;   ?
    je   button         ; ᫨  -  button
    cmp  eax,6          ;   ?
    je   mouse            ; ᫨  -  key

    jmp  still          ; ᫨ 㣮 ᮡ⨥ -  砫 横


;---------------------------------------------------------------------
  key:;    
                 ; 㭪 2 -   ᨬ ( ah)
    mcall 2

    ;call draw_window    ; 뢠 楤 ᮢ 
    call CompMove

    jmp  still          ;   砫 横

  mouse:;    
                 ; 㭪 2 -   ᨬ ( ah)

    mcall 37, 3
    test eax, 100000000b
    jz still

    mov edx, [field]
    test edx, 16
    jnz WcPs

    test edx, 1
    jnz step_PO

    test edx, 0x2000
    jz still
    jmp step_PX

    step_PO:
    test edx, 0x1000
    jz still
    step_PX:


    mcall 37, 1

    mov ebx, eax
    shr ebx, 16
    and eax, 0xff

    cmp ebx, 2
    jb still
    cmp ebx, 95
    ja still

    cmp eax, 5
    jb still
    cmp eax, 5+95
    ja still

    ;sub ebx, 2
    sub eax, 5

    shr ebx, 5
    shr eax, 5

    mov ecx, 6
    mul ecx

    shl ebx, 1

    shl eax, 8
    or eax, ebx

    mov ebx, 0x80000000
    mov cl, ah

    shr ebx, cl; mov on y

    mov cl, al
    shr ebx, cl; mov on x

    mov edx, [field]

    test edx, ebx  ;test is empty
    jnz still ; if not skip
    or edx, ebx ;set is not empty
    shr ebx, 1

    test edx, 1
    jz MWrO
    or edx,ebx
    jmp Mout
    MWrO:


    Mout:
    inc edx
    mov [field], edx

WcPs:

    rds:
    call draw_window    ; 뢠 楤 ᮢ 

    jmp  still          ;   砫 横

;---------------------------------------------------------------------

  button:
    mcall 17            ; 17 -  䨪 ⮩ 

    cmp   ah, 2
    jne b_next0
    and [field], 0x3000
    jmp rds

    b_next0:
    cmp   ah, 3
    jne b_next1
    xor [field], 0x1000
    jmp rds

   b_next1:
    cmp   ah, 4
    jne b_next2
    xor [field], 0x2000
    jmp rds

   b_next2:
    cmp   ah, 1         ; ᫨     ஬ 1,
    jne   still         ;  

  .exit:
    mcall -1            ;   ணࠬ


;---------------------------------------------------------------------
;---       ----------------------------------
;---------------------------------------------------------------------

draw_window:

    mcall 12, 1       ; 㭪 12: ᮮ   砫 ᮢ

    mcall 48, 3, sc,sizeof.system_colors
        mov   eax, [sc.work_button_text]    ; 梥 䮭
        or    eax, 0x90000000        ;  ⨯ ப
        mov [butTextColAPar], eax


    mcall 26 , 5
    cmp eax, 4
    jnz NG_eng
    mov [St_NG], St_NG_Ru
    mov [St_Comp], St_Comp_Ru
    mov [St_Player], St_Player_Ru
    jmp NG_out
    NG_eng:
    mov [St_NG], St_NG_Eng
    mov [St_Comp], St_Comp_Eng
    mov [St_Player], St_Player_Eng
    NG_out:
    mcall 4, <105, (5+96-16)>,[butTextColAPar] ,


    mov   edx, [sc.work]         ; 梥 䮭
    or    edx, 0x34000000        ;  ⨯  3
    mcall 48, 4
    mov ecx, 200*65536+106
    add ecx,eax
    mcall 0, <200,205>,, , ,title



    mcall 8 , 100*65536+96 , (5+96-20)*65536+20 ,2 , [sc.work_button]

    mcall  ,  , (5+96-42)*65536+20 ,3 ,

    mcall  ,  , (5+96-64)*65536+20 ,4 ,

    mcall 4, <105, (5+96-16)>,[butTextColAPar] ,[St_NG]

    mcall , <105, (5+96-16-22)>, , St_X

    mcall , <105, (5+96-16-44)>, , St_O

    test [field], 0x1000
    jnz b1p
    mov edx, [St_Comp]
    jmp b1c
    b1p:
    mov edx, [St_Player]
    b1c:
    mcall 4, <105+15, (5+96-16-22)>,[butTextColAPar] ,

    test [field], 0x2000
    jnz b2p
    mov edx, [St_Comp]
    jmp b2c
    b2p:
    mov edx, [St_Player]
    b2c:
    mcall 4, <105+15, (5+96-16-44)>,[butTextColAPar] ,

;#|
    mcall 38 , 0, 5*65536+101 , [sc.work_graph]
    mcall  , 1*65536+1 , ,

    mcall  , 31*65536+31
    mcall  , 32*65536+32

    mcall  , 63*65536+63
    mcall  , 64*65536+64

    mcall  , 95*65536+95
    mcall  , 96*65536+96


;#-
    mcall 38 , 0*65536+96, 5*65536+5 ,
    mcall  , , 6*65536+6 ,

    mcall  , , (5+31)*65536+(5+31) ,
    mcall  , , (5+32)*65536+(5+32) ,

    mcall  , , (5+63)*65536+(5+63) ,
    mcall  , , (5+64)*65536+(5+64) ,

    mcall  , , (5+95)*65536+(5+95) ,
    mcall  , , (5+96)*65536+(5+96) ,

draw_XOs:
   mov eax, 0
   mov edx, 0x80000000
L1:
   push ax
   push edx


  test [field], edx
  jz L1_cont
;x
   ;AH - ostatok AL
    ;mov ax, 8
    mov ebx, 3 ; bl 뢠 ᬥ饭.
    div bl
    mov cl, al

    shr ax, 8
    shl ax, 5
    ;obedenenoe
    ;shr ax, 3

    mov bx, ax
    shl eax, 16
    or eax, ebx
;y
    shl cx, 5
    mov bx, cx
    shl ecx, 16
    or ecx, ebx


   shr edx, 1
   test [field], edx
   jnz DrO

   call draw_X

   jmp L1_cont
   DrO:
   call draw_O



L1_cont:
    pop edx
    shr edx, 2

    pop ax
    inc ax
    cmp ax, 9
    jnz L1



call WinCon

call CompMove
cmp eax, 0
jnz draw_XOs




;SkipToBtn:







    mcall 12, 2                  ; 㭪 12.2, 稫 ᮢ

    ret                          ; 室  楤







;---------------------------------------------------------------------
;---     ----------------------------------------------
;---------------------------------------------------------------------

sc system_colors
butTextColAPar rd 1

field dd 0
;field dd 0xAFBEA000

title db 'XOs',0
St_X db 'O:',0
St_O db 'X:',0

St_NG rd 1
St_Comp rd 1
St_Player rd 1

St_NG_Ru db ' ',0
St_NG_Eng db 'New game',0
St_Comp_Ru db '',0
St_Player_Ru db 'ப',0
St_Comp_Eng db 'Computer',0
St_Player_Eng db 'Player',0
;---------------------------------------------------------------------

I_END:                  ; ⪠  ணࠬ
  rb 4096               ;   ⥪
align 16
STACKTOP:               ; ⪠ 設 ⥪ (  ⥪
                        ;   ஭ 㬥襭 ᮢ, ⮬
                        ;      ணࠬ 砥
                        ; ࠭ 祬  設)
MEM:                    ; ⪠ 㪠뢠   ணࠬ 
                        ; ࠧ ᯮ㥬  ⨢ 
;  ⪨ MEM ᥣ    祬  ⪨ I_END.
; ⪠ STACKTOP  ᯮ ᫥ ⪨ I_END  । ⪮
;   MEM. STACKTOP  室  । I_END,    ࠢ쭮.
;  ⮪    묨 ﬨ,  ᮡ
;   ࠢ 冷  ᯮ.